#include "xbasic_types.h"
#include "xio.h"
#include "xparameters.h"

#include "video8.h"

void tetris_draw_square(int x, int y, int rgb)
{
  Xuint32 a, rgbm, rgbtb, rgbl, rgbr;
  int i;

  rgbm =rgb & 0xFF00; rgbm = rgbm | (rgbm>>8) | (rgbm<<8) | (rgbm<<16);
  rgbtb=rgb & 0x00FF; rgbtb = rgbtb | (rgbtb<<8) | (rgbtb<<16) | (rgbtb<<24);
  rgbl = (rgbtb & 0xFF000000) | (rgbm & 0x00FFFFFF);
  rgbr = (rgbtb & 0x000000FF) | (rgbm & 0xFFFFFF00);

  a = VGA_START_ADDRESS + ((y*VGA_W + x) << 4);

  for(i=0;i<16;i+=4){
    XIo_Out32(a + i, rgbtb);
    XIo_Out32(a + 15*VGA_W + i, rgbtb);
  }

  a+=VGA_W;

  for(i=0;i<14;i++){
    XIo_Out32(a  , rgbl);
    XIo_Out32(a+4, rgbm);
    XIo_Out32(a+8, rgbm);
    XIo_Out32(a+12, rgbr);
    a+=VGA_W;
  }
}


void tetris_draw_brick(int x, int y, int rgb)
{
  
  Xuint32 a, rgbm, rgbtb, rgbl, rgbr;
  int i;

  rgbm =rgb & 0xFF00; rgbm = rgbm | (rgbm>>8) | (rgbm<<8) | (rgbm<<16);
  rgbtb=rgb & 0x00FF; rgbtb = rgbtb | (rgbtb<<8) | (rgbtb<<16) | (rgbtb<<24);
  rgbl = (rgbtb & 0xFF000000) | (rgbm & 0x00FFFFFF);
  rgbr = (rgbtb & 0x000000FF) | (rgbm & 0xFFFFFF00);

  a = VGA_START_ADDRESS + ((y*VGA_W + x) << 4);

 for(i=0;i<16;i+=4){
    XIo_Out32(a + i, rgbtb);
    XIo_Out32(a + 7*VGA_W + i, rgbtb);
    XIo_Out32(a + 8*VGA_W + i, rgbtb);
    XIo_Out32(a + 15*VGA_W + i, rgbtb);   
  }  
 
 a+=VGA_W;

 for(i=0;i<6;i++){
   XIo_Out32(a  , rgbm);
   XIo_Out32(a+4, rgbr);
   XIo_Out32(a+8, rgbl);
   XIo_Out32(a+12, rgbm);
   a+=VGA_W;
  }

 a+=VGA_W*2;
 
 for(i=0;i<6;i++){
   XIo_Out32(a  , rgbl);
   XIo_Out32(a+4, rgbm);
   XIo_Out32(a+8, rgbm);
   XIo_Out32(a+12, rgbr);
   a+=VGA_W;
  }


}
