--------------------------------------------------------------------------------
-- lmb_lmb_bram_if_cntlr_0_wrapper.vhd
--------------------------------------------------------------------------------
LIBRARY IEEE;
USE IEEE.STD_LOGIC_1164.ALL;

-- synthesis translate_off
LIBRARY UNISIM;
USE UNISIM.VCOMPONENTS.ALL;
-- synthesis translate_on

LIBRARY lmb_lmb_bram_if_cntlr_v1_00_a;
USE lmb_lmb_bram_if_cntlr_v1_00_a.ALL;

ENTITY lmb_lmb_bram_if_cntlr_0_wrapper IS
PORT (
	-- instance lmb_lmb_bram_if_cntlr_0
	LMB_Clk : IN STD_LOGIC;
	LMB_Rst : IN STD_LOGIC;
	ILMB_ABus : IN STD_LOGIC_VECTOR(0 TO 31);
	ILMB_ReadStrobe : IN STD_LOGIC;
	ILMB_AddrStrobe : IN STD_LOGIC;
	Instr_DBus : OUT STD_LOGIC_VECTOR(0 TO 31);
	Instr_Ready : OUT STD_LOGIC;
	DLMB_ABus : IN STD_LOGIC_VECTOR(0 TO 31);
	DLMB_WriteDBus : IN STD_LOGIC_VECTOR(0 TO 31);
	DLMB_AddrStrobe : IN STD_LOGIC;
	DLMB_ReadStrobe : IN STD_LOGIC;
	DLMB_WriteStrobe : IN STD_LOGIC;
	DLMB_BE : IN STD_LOGIC_VECTOR(0 TO 3);
	Data_DBus : OUT STD_LOGIC_VECTOR(0 TO 31);
	Data_Ready : OUT STD_LOGIC;
	BRAM_Rst_A : OUT STD_LOGIC;
	BRAM_Clk_A : OUT STD_LOGIC;
	BRAM_EN_A : OUT STD_LOGIC;
	BRAM_WEN_A : OUT STD_LOGIC_VECTOR(0 TO 3);
	BRAM_Addr_A : OUT STD_LOGIC_VECTOR(0 TO 31);
	BRAM_Din_A : IN STD_LOGIC_VECTOR(0 TO 31);
	BRAM_Dout_A : OUT STD_LOGIC_VECTOR(0 TO 31);
	BRAM_Rst_B : OUT STD_LOGIC;
	BRAM_Clk_B : OUT STD_LOGIC;
	BRAM_EN_B : OUT STD_LOGIC;
	BRAM_WEN_B : OUT STD_LOGIC_VECTOR(0 TO 3);
	BRAM_Addr_B : OUT STD_LOGIC_VECTOR(0 TO 31);
	BRAM_Din_B : IN STD_LOGIC_VECTOR(0 TO 31);
	BRAM_Dout_B : OUT STD_LOGIC_VECTOR(0 TO 31));
END lmb_lmb_bram_if_cntlr_0_wrapper;

ARCHITECTURE IMP OF lmb_lmb_bram_if_cntlr_0_wrapper IS

--------------------------------------------------------------------------------
COMPONENT lmb_lmb_bram_if_cntlr IS
GENERIC (
	C_BASEADDR : STD_LOGIC_VECTOR(0 TO 31) := X"00000000";
	C_HIGHADDR : STD_LOGIC_VECTOR(0 TO 31) := X"000007ff";
	C_MASK : STD_LOGIC_VECTOR(0 TO 31) := X"00800000";
	C_LMB_AWIDTH : INTEGER := 32;
	C_LMB_DWIDTH : INTEGER := 32);
PORT (
	LMB_Clk : IN STD_LOGIC;
	LMB_Rst : IN STD_LOGIC;
	ILMB_ABus : IN STD_LOGIC_VECTOR(0 TO C_LMB_AWIDTH-1);
	ILMB_ReadStrobe : IN STD_LOGIC;
	ILMB_AddrStrobe : IN STD_LOGIC;
	Instr_DBus : OUT STD_LOGIC_VECTOR(0 TO C_LMB_DWIDTH-1);
	Instr_Ready : OUT STD_LOGIC;
	DLMB_ABus : IN STD_LOGIC_VECTOR(0 TO C_LMB_AWIDTH-1);
	DLMB_WriteDBus : IN STD_LOGIC_VECTOR(0 TO C_LMB_DWIDTH-1);
	DLMB_AddrStrobe : IN STD_LOGIC;
	DLMB_ReadStrobe : IN STD_LOGIC;
	DLMB_WriteStrobe : IN STD_LOGIC;
	DLMB_BE : IN STD_LOGIC_VECTOR(0 TO C_LMB_DWIDTH/8-1);
	Data_DBus : OUT STD_LOGIC_VECTOR(0 TO C_LMB_DWIDTH-1);
	Data_Ready : OUT STD_LOGIC;
	BRAM_Rst_A : OUT STD_LOGIC;
	BRAM_Clk_A : OUT STD_LOGIC;
	BRAM_EN_A : OUT STD_LOGIC;
	BRAM_WEN_A : OUT STD_LOGIC_VECTOR(0 TO (C_LMB_DWIDTH/8)-1);
	BRAM_Addr_A : OUT STD_LOGIC_VECTOR(0 TO C_LMB_AWIDTH-1);
	BRAM_Din_A : IN STD_LOGIC_VECTOR(0 TO C_LMB_DWIDTH-1);
	BRAM_Dout_A : OUT STD_LOGIC_VECTOR(0 TO C_LMB_DWIDTH-1);
	BRAM_Rst_B : OUT STD_LOGIC;
	BRAM_Clk_B : OUT STD_LOGIC;
	BRAM_EN_B : OUT STD_LOGIC;
	BRAM_WEN_B : OUT STD_LOGIC_VECTOR(0 TO (C_LMB_DWIDTH/8)-1);
	BRAM_Addr_B : OUT STD_LOGIC_VECTOR(0 TO C_LMB_AWIDTH-1);
	BRAM_Din_B : IN STD_LOGIC_VECTOR(0 TO C_LMB_DWIDTH-1);
	BRAM_Dout_B : OUT STD_LOGIC_VECTOR(0 TO C_LMB_DWIDTH-1));
END COMPONENT;

--------------------------------------------------------------------------------
-- internal signals
--------------------------------------------------------------------------------

BEGIN

--------------------------------------------------------------------------------
-- Power assignments
--------------------------------------------------------------------------------
-- Constant assignments
--------------------------------------------------------------------------------
-- Top-level port assignments
--------------------------------------------------------------------------------
-- Lower-level assignments

--------------------------------------------------------------------------------
lmb_lmb_bram_if_cntlr_0_i : lmb_lmb_bram_if_cntlr
GENERIC MAP (
	C_BASEADDR => X"00000000",
	C_HIGHADDR => X"000007ff",
	C_MASK => X"00800000",
	C_LMB_AWIDTH => 32,
	C_LMB_DWIDTH => 32)
PORT MAP (
	LMB_Clk => LMB_Clk,
	LMB_Rst => LMB_Rst,
	ILMB_ABus => ILMB_ABus,
	ILMB_ReadStrobe => ILMB_ReadStrobe,
	ILMB_AddrStrobe => ILMB_AddrStrobe,
	Instr_DBus => Instr_DBus,
	Instr_Ready => Instr_Ready,
	DLMB_ABus => DLMB_ABus,
	DLMB_WriteDBus => DLMB_WriteDBus,
	DLMB_AddrStrobe => DLMB_AddrStrobe,
	DLMB_ReadStrobe => DLMB_ReadStrobe,
	DLMB_WriteStrobe => DLMB_WriteStrobe,
	DLMB_BE => DLMB_BE,
	Data_DBus => Data_DBus,
	Data_Ready => Data_Ready,
	BRAM_Rst_A => BRAM_Rst_A,
	BRAM_Clk_A => BRAM_Clk_A,
	BRAM_EN_A => BRAM_EN_A,
	BRAM_WEN_A => BRAM_WEN_A,
	BRAM_Addr_A => BRAM_Addr_A,
	BRAM_Din_A => BRAM_Din_A,
	BRAM_Dout_A => BRAM_Dout_A,
	BRAM_Rst_B => BRAM_Rst_B,
	BRAM_Clk_B => BRAM_Clk_B,
	BRAM_EN_B => BRAM_EN_B,
	BRAM_WEN_B => BRAM_WEN_B,
	BRAM_Addr_B => BRAM_Addr_B,
	BRAM_Din_B => BRAM_Din_B,
	BRAM_Dout_B => BRAM_Dout_B);

END ARCHITECTURE IMP;
